#include <SDL.h>
#include <iostream>
#include <chrono>
#include <thread>

#include "tic_tac_toe.h"

using namespace std::chrono_literals;

int main(int, char**) {
    /* SDL initialisieren */
    const int width = 1024;
    const int height = 768;

    // Engine-Objekt erzeugen
    TicTacToe game(width, height, "Tic Tac Toe");

    /* Event Loop */
    const auto time_per_frame = std::chrono::milliseconds(1000 / 60);

    for (;;) {
        auto time_begin = std::chrono::steady_clock::now();

        if (!game.processEvents()) {
            return 0;
        }

        game.update();

        game.render();

        auto time_end = std::chrono::steady_clock::now();
        auto time_delta = time_end - time_begin;

        if (time_delta < time_per_frame) {
            std::this_thread::sleep_for(time_per_frame - time_delta);
        }
    }

    return 0;
}
